#ifndef RING_H
#define RING_H

#include "sys.h" 

typedef struct _ring{

	uint8_t *buffer;
	
	uint32_t size;
	
	uint32_t headPos;
	
	uint32_t count;
	
	uint32_t tailPos;
	
	uint8_t overWriteFlag;
	
} ring_t;

ring_t* ring_buffer_init(uint32_t size, uint8_t overWriteFlag);

int ring_buffer_clear(ring_t *ring);

int ring_buffer_available(ring_t *ring) ;

int ring_buffer_write(ring_t *ring, uint8_t *data, uint32_t length) ;

int ring_buffer_read(ring_t *ring, uint8_t *data, uint32_t size);

#endif

